var command           = null;
var color_status      = 0;
var flag_blink_status = 0;
var blink_loop_status = 64;
var flag_loading      = 0;
var url_current       = "http://www.jma.go.jp/JMA_HP/jp/quake/";
var url_previous      = null;
var url_next          = null;

var __hexstring = "0123456789ABCDEF";
function __convert_to_hex( num ) {
    var div = parseInt( num / 16 );
    var rem = num - div * 16;
    if ( div < 0 ) div = 0;
    if ( div > 15 ) div = 15;
    if ( rem < 0 ) rem = 0;
    if ( rem > 15 ) rem = 15;
    return __hexstring.charAt( div ) + __hexstring.charAt( rem );
}

function LoadingIcon( element ) {
    if ( element == null ) return;
    this.element = element;
    this.x = 0;
    this.y = 0;
    //this.element.style.opacity = 0;
    this.counter = 0;
    this.isRunning = false;
    this.radius  = 150;
    this.centerX = 200;
    this.centerY = 200;
}

var loadingIcon = null;

function LoadingIcon_rotate( self ) {
    if ( self == null ) return;
    self.counter ++;
    if ( self.counter % 3 == 0 ) {
        var count = self.counter;
        var x = Math.cos( count / 20 ) * self.radius + self.centerX;
        var y = Math.sin( count / 20 ) * self.radius + self.centerY;
        self.element.style.top  = y + "px";
        self.element.style.left = x + "px";
    }
}

function LoadingIcon_start( self ) {
    if ( self == null ) return;
    self.element.style.opacity = 0.5;
//    self.element.style.zIndex = 999;
}

function LoadingIcon_hide( self ) {
    if ( self == null ) return;
    self.element.style.opacity = 0;
}


function __blink_status() {
    var elem_status = document.getElementById( "status" );
    if ( elem_status ) {
        var col = "#" + __convert_to_hex( color_status )
            + __convert_to_hex( color_status * 2 + 64 )
            + __convert_to_hex( color_status + 128 );
        elem_status.style.color = col;
	
        color_status = ( color_status + 1 ) % blink_loop_status;
        if ( flag_blink_status == 1 ) {
            //showStatus( "ROTATION START " + loadingIcon.element.style.top );
            LoadingIcon_rotate( loadingIcon );
            //showStatus( "ROTATION END " + loadingIcon.counter + " " + flag_blink_status );
            setTimeout( __blink_status, 10 );
        } else {
            LoadingIcon_hide( loadingIcon );
            elem_status.style.color = 'black';
        }
    }
}

function blinkStatus() {
    flag_blink_status = 1;
    LoadingIcon_start( loadingIcon );
    setTimeout( __blink_status, 20 );
}

function showStatus( message ) {
    //flag_blink_status = 0;
    var elem_status = document.getElementById( "status" );
    if ( elem_status ) {
        elem_status.innerText = message;
        elem_status.style.color = 'black';
    }
}

function stopBlink() {
    flag_blink_status = 0;
    showStatus( "" );
}

function __resetWebButton() {
    resetButtonImage( "button-web" );
}

function openJMASite() {
    if ( window.widget ) {
        setPushedButtonImage( "button-web" );
        setTimeout( __resetWebButton, 500 );
        
        if ( url_current ) {
            widget.openURL( url_current );
        }
    } else {
        showStatus( "Cannot open website" );
    }
}

function displayResult( outputs ) {
    var comment = "";
    var region_info = "";
    var num_info_start = 3;
    if ( outputs.length >= num_info_start ) {
        var url_current_cache = url_current;
        url_current  = outputs[ 0 ].substring( 4, outputs[ 0 ].length );
        url_previous = outputs[ 1 ].substring( 4, outputs[ 1 ].length );
        url_next     = outputs[ 2 ].substring( 4, outputs[ 2 ].length );
        resetButtonImage( "button-prev" );
        if ( url_next.length > 5 ) {
            resetButtonImage( "button-post" );
        } else {
            setTransparentButtonImage( "button-post" );
        }
        
        for ( var i = num_info_start; i < outputs.length; i++ ) {
            if ( outputs[ i ] == "//-" ) {
                setRegionalData( outputs, i + 1, outputs.length );
                break;
            } else {
                comment += outputs[ i ] + "<br/>";
            }
        }
        document.getElementById( "comment" ).innerHTML = comment;
    }
}

function endHandler( event ) {
    if ( command != null ) {
        if ( url_current != null ) resetButtonImage( "button-new" );
        if ( url_previous != null )resetButtonImage( "button-prev" );
        if ( url_next != null ) resetButtonImage( "button-post" );
        var out = command.outputString;
        if ( out ) {
            displayResult( out.split( "\n" ) );
            stopBlink();
        } else {
            showStatus( "ERROR !! : Failed to load" );
            //showStatus( url_current );
        }
    }
    flag_blink_status = 0;
    flag_loading = 0;
}

function setRegionalData( data, start, end ) {
    var height = ( ( end - start ) * 11 );
    html = "<table id=\"regiontable\" height=\"" + height + "\">";
    for ( var k = start; k < end; k++ ) {
        var items = data[ k ].split( "," );
        if ( items != null && items.length >= 3 ) {
            html += "<tr><td>" + items[ 0 ] + "</td><td>" + items[ 1 ] + "</td><td>" + items[ 2 ] + "</td>";
        }
    }
    html += "</table>";
    document.getElementById( "region" ).innerHTML  = html;    
}

function cancelLoading() {
    if ( command != null ) {
	command.cancel();
	flag_loading = 0;
    }
}

function loadLatest() {
    __loadLatest( "-latest" );
}

function loadPreviousInformation() {
    if ( url_previous == null ) return;
    setPushedButtonImage(  "button-prev" );
    proceedingOutput = "";
    __pos_scanned = 0;
    if ( flag_loading == 1 ) {
        cancelLoading();
    }
    flag_loading = 1;
    showStatus( "Loading..." );
    if ( window.widget ) {
        blinkStatus();
        command = widget.system( "/usr/bin/python get_jma_data.py \"" + url_previous + "\"", endHandler );
    }
    //resetButtonImage(  "button-prev" );
}

var proceedingOutput = "";
var __tag_end        = "<!--END-->";
var __pos_scanned    = 0;

function ongoingOutputHandler( __out ) {
    //__pos_scanned += __out.length;
    document.getElementById( "status2" ).innerText = "PROCEEDIN!!!";//__out;//"proceeding" + __pos_scanned;
    return;
//     proceedingOutput += __out;
//     var tail = proceedingOutput - __tag_end.length;
//     for ( ; __pos_scanned < tail; __pos_scanned ++ ) {
//         if ( proceedingOutput.substr( i, i + __tag_end.length ) == __tag_end ) {
//             displayResult( proceedingOutput.split( "\n" ) );
//             proceedingOutput = proceedingOutput( __pos_scanned + __tag_end.length + 1, proceedingOutput.length );
//             __pos_scanned = 0;
//         }
//     }
}

function __asynchronousEndHandler( event ) {
    stopBlink();
    flag_loading = 0;
}

function loadNextInformation() {
    if ( url_next == null || url_next.length < 5 ) return;

    setPushedButtonImage(  "button-post" );
    if ( flag_loading == 1 ) {
        cancelLoading();
    }
    flag_loading = 1;
    showStatus( "Loading..." );

    if ( window.widget ) {
        blinkStatus();
        blinkStatus();
        command = widget.system( "/usr/bin/python get_jma_data.py \"" + url_next + "\"", endHandler );
    }
    //resetButtonImage(  "button-post" );
}

function setPushedButtonImage( id ) {
    var elem = document.getElementById( id );
    if ( elem ) {
        elem.src = "img/" + id + "-pushed.png";
    }
}

function resetButtonImage( id ) {
    var elem = document.getElementById( id );
    if ( elem ) {
        elem.src = "img/" + id + ".png";
    }
}

function setTransparentButtonImage( id ) {
    var elem = document.getElementById( id );
    if ( elem ) {
        elem.src = "img/" + id + "-transparent.png";
    }
}

function deleteCache() {
    if ( window.widget ) {
        widget.system( "/usr/bin/python remove_cache.py", __dummyEndHandler )
    }
}

function __dummyEndHandler( event ) {
}

function __loadLatest( option ) {
    setPushedButtonImage(  "button-new" );
    if ( flag_loading == 1 ) {
        cancelLoading();
    }
    flag_loading = 1;
    showStatus( "Loading..." );
    if ( window.widget ) {
        blinkStatus();
        url_current = "http://www.jma.go.jp/JMA_HP/jp/quake/";
        var pycommand = "";
        if ( option == null || option == "" ) {
            pycommand = "/usr/bin/python get_jma_data.py " + url_current;
        } else {
            pycommand = "/usr/bin/python get_jma_data.py " + option;
        }
        //pycommand = "/usr/bin/python dump_dummy.py";
        command = widget.system( pycommand, endHandler );
        //command.onreadoutput = ongoingOutputHandler;
        //widget.system( pycommand, __asynchronousEndHandler ).onreadoutput = __processReader;//endHandler );
        //command = widget.system( pycommand, __asynchronousEndHandler );//endHandler );
        //command.onReadOutput = __processReader;
    }
}

function setup() {
    //setTransparentButtonImage( "button-new" );

    loadingIcon = new LoadingIcon( document.getElementById( "loading" ) );

    setTransparentButtonImage( "button-prev" );
    setTransparentButtonImage( "button-post" );
    deleteCache();
    __loadLatest();
}
